<?php
/**
 * フロントエンド表示処理スクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_category_view
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * フロントエンドタスク表示処理
 */
class HTML_kingyoya_category_view {

	/** @var string of option */
	var $option = null;
	/** @var int of id */
	var $id = null;

	/** @var mosCategory for view */
	var $category = null;
	/** @var mosSection for view */
	var $section = null;

	/** @var int of Itemid */
	var $Itemid = null;

	/** @var string of template */
	var $template = null;

	/**
	 * 表示処理
	 */
	function show() {
		$option =& $this->option;
		$id =& $this->id;
		$category =& $this->category;
		$section =& $this->section;
		$template =& $this->template;
		$Itemid =& $this->Itemid;

		if (!$option) {
			trigger_error('Failed get option', E_USER_WARNING);
			return;
		}
		if (!$id) {
			trigger_error('Failed get id', E_USER_WARNING);
			return;
		}
		if (!$category) {
			trigger_error('Failed get category', E_USER_WARNING);
			return;
		}
		if (!$section) {
			trigger_error('Failed get section', E_USER_WARNING);
			return;
		}
		if (!$template) {
			trigger_error('Failed get template', E_USER_WARNING);
			return;
		}

		if (!preg_match('/^com_[0-9a-zA-Z_]+$/', $option)) {
			trigger_error("Failed get option: {$option}", E_USER_WARNING);
			return;
		}
		if (!is_int($id) || !($id > 0)) {
			trigger_error("Failed get id: {$id}", E_USER_WARNING);
			return;
		}
		if (!is_object($category)) {
			trigger_error("Failed get category", E_USER_WARNING);
			return;
		}
		if (!is_object($section)) {
			trigger_error("Failed get section", E_USER_WARNING);
			return;
		}
		if (!is_string($template)) {
			trigger_error("Failed get template", E_USER_WARNING);
			return;
		}

		if (isset($Itemid)) {
			if (!$Itemid) {
				trigger_error('Failed get Itemid', E_USER_WARNING);
				return;
			} else if (!preg_match('/^[1-9][0-9]*$/', $Itemid)) {
				trigger_error("Failed get Itemid: {$Itemid}", E_USER_WARNING);
				return;
			}
		}

		$template = <<<__TEMPLATE__
<mos:tmpl name="category">
{$template}
</mos:tmpl>
__TEMPLATE__;

		global $mosConfig_live_site;
		global $mosConfig_absolute_path;
		require_once "{$mosConfig_absolute_path}/includes/patTemplate/patTemplate.php";
		$patTemplate = patFactory::createTemplate();
		$patTemplate->readTemplatesFromInput($template, 'String');
		$patTemplate->addVar('category', 'id', $id);
		$patTemplate->addVar('category', 'name', $category->name);
		$patTemplate->addVar('category', 'title', $category->title);
		$patTemplate->addVar('category', 'description', $category->description);
		$patTemplate->addVar('category', 'image', "{$mosConfig_live_site}/images/stories/{$category->image}");
		$patTemplate->addVar('category', 'section_id', $section->id);
		$patTemplate->addVar('category', 'section_name', $section->name);
		$patTemplate->addVar('category', 'section_title', $section->title);
		$patTemplate->addVar('category', 'section_description', $section->description);
		$patTemplate->addVar('category', 'section_image', "{$mosConfig_live_site}/images/stories/{$section->image}");
		$patTemplate->addVar('category', 'br', "<br />");
		$patTemplate->displayParsedTemplate('category');

	}

}
